////////////////////////////////////////////////////////////////////////////////////////
// itm.js
// Copyright (C) 2006-2010 Masayuki Iwai all rights reserved.
// ----
// 2006.10.11 ver.0.1.0.0
// 2006.10.13 ver.0.2.0.0
// 2006.10.16 ver.0.2.1.0
// 2006.10.16 ver.0.2.2.0
// 2006.10.17 ver.0.2.3.0
// 2006.11.04 ver.0.2.4.0
// 2006.11.28 ver.0.3.0.0
// 2007.01.02 ver.0.4.0.0
// 2007.03.06 ver.0.4.1.0
// 2007.03.14 ver.0.5.0.0
// 2007.09.17 ver.0.6.0.0
// 2007.11.04 ver.0.6.1.0
// 2008.02.03 ver.0.6.2.0
// 2008.05.09 ver.0.7.0.0
// 2008.05.12 ver.0.7.1.0
// 2008.06.05 ver.0.7.2.0
// 2008.11.05 ver.0.8.0.0
// 2009.08.28 ver.0.8.1.0
// 2009.09.09 ver.0.8.2.0
// 2009.09.25 ver.0.8.3.0
// 2010.01.26 ver.0.8.4.0
////////////////////////////////////////////////////////////////////////////////////////


var g_Conf = {
	app_name             : "In the Mood", 
	app_code             : "inthemood", 
	version              : "ver.0.8.4", 
	width                : 320, 
	front_height         : 80, 
	back_height          : 228, 
	post_offset          : 0, 
	format               : "", 
	format_default       : "\u266a{name} - {artist}", 
	mood_text            : "", 
	mood_text_index      : 0, 
	current_song         : "", 
	current_artist       : "", 
	itunes_paused        : 0, 
	paused_index         : 0, 
	preset_index         : 0, 
	preset_count         : 10, 
	preset_text          : {0:"", 1:"", 2:"", 3:"", 4:"", 5:"", 6:"", 7:"", 8:"", 9:""}, 
	use_growl            : 0, 
	prefs_tab_count      : 2, 
	im_services          : {
		"adium": {use:0}, 
		"ichat": {use:0}, 
		"skype": {use:1}
	}, 
	post_services        : {
		"blipfm": {
			name         : "blipfm", 
			label        : "Blip.fm", 
			use          : 0, 
			url          : "http://api.blip.fm/blip/post.json", 
			url_getparams: "http://www.mybdesign.com/itm/blipfm_get_params.php", 
			url_findsongs: "http://api.blip.fm/search/findSongs.json", 
			max_length   : 150, 
			params       : "apiKey=3df2ca94842aab165142", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}, 
		"friendfeed": {
			name         : "friendfeed", 
			label        : "FriendFeed", 
			use          : 0, 
			url          : "http://friendfeed.com/api/share", 
			max_length   : 140, 
			params       : "", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}, 
		"jaiku": {
			name         : "jaiku", 
			label        : "Jaiku", 
			use          : 0, 
			url          : "http://api.jaiku.com/json", 
			max_length   : 140, 
			params       : "method=presence.send&icon=367", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}, 
		"twitter": {
			name         : "twitter", 
			label        : "Twitter", 
			use          : 0, 
			url          : "https://twitter.com/statuses/update.json", 
			max_length   : 140, 
			params       : "", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}, 
		"wassr": {
			name         : "wassr", 
			label        : "Wassr", 
			use          : 0, 
			url          : "http://api.wassr.jp/statuses/update.json", 
			max_length   : 255, 
			params       : "", 
			id           : "", 
			pw           : "", 
			auto         : 0, 
			comment_only : 0
		}
	}, 
	post_timeout         : 15, 
	post_error           : {
		304: "Not Modified", 
		400: "Bad Request", 
		401: "Not Authorized", 
		403: "Forbidden", 
		404: "Not Found", 
		500: "Internal Server Error", 
		502: "Bad Gateway", 
		503: "Service Unavailable", 
		997: "Song Not Found", 
		998: "Request Timed Out", 
		999: "Unknown Error"
	}, 
	last_checked         : 0, 
	check_for_updates    : 0, 
	check_for_upd_url    : "http://www.mybdesign.com/itm/latest_version.txt", 
	check_for_upd_timeout: 30, 
	check_for_upd_every  : 24 * 60 * 60, 
	cancel_auto_posting  : 1, 
	"": ""
};

var g_nPrefsTabIndex = 1;

var g_InfoButton;
var g_DoneButton;
var g_CancelButton;

var g_bSelectMoodTextShown = false;
var g_SelectMoodTextAnimator = null;
var g_SelectMoodTextAnimation = null;

var g_CheckForUpdatesRequest = null;
var g_CheckForUpdatesTimer = null;

var g_PostRequest = {};
var g_PostTimer = {};
var g_nPostCount = 0;
var g_nPostButtonStatus = 0;
var g_PostErrors = [];
var g_nBlipCount = 0;


//////// Initialize widget
function Initialize()
{
	if(window.widget)
		window.widget.onshow = CheckForUpdates;

	document.getElementById("version").innerText = g_Conf.version;

	g_InfoButton = new AppleInfoButton(
		document.getElementById("info_button"), 
		document.getElementById("front"), 
		"white", "white", 
		ShowPrefs
	);

	g_DoneButton = new AppleGlassButton(
		document.getElementById("done_button"), 
		"done", 
		HidePrefsWithApplyChanges
	);

	g_CancelButton = new AppleGlassButton(
		document.getElementById("cancel_button"), 
		"cancel", 
		HidePrefsWithoutApplyChanges
	);

	// Load preferences
	LoadPreferences();
	SavePreferences(false);

	// Set up selections
	var sel_paused = document.getElementById("select_paused_index");
	var sel_preset = document.getElementById("select_preset_index");

	sel_paused.options.length = g_Conf.preset_count;
	sel_preset.options.length = g_Conf.preset_count;
	for(i=0; i<g_Conf.preset_count; i++)
	{
		sel_paused.options[i].text = i + ": " + g_Conf.preset_text[i];
		sel_paused.options[i].value = i;
		sel_preset.options[i].text = i + ": " + g_Conf.preset_text[i];
		sel_preset.options[i].value = "";
	}

	RestorePreferences();
	UsePresetTextWheniTunesPausesChecked();
	UpdateServicesStatus();

	MoodTextChanged(false);
	EnablePostButton();
}

//////// Called when widget is closed
function Unload()
{
	if(itm_plugin)
		itm_plugin.RemoveDelegate();
}

//////// Load preferences
function LoadPreferences()
{
	var i, temp;

	if(window.widget)
	{
		g_Conf.format = g_Conf.format_default;
		if(!IsUndefined(temp = widget.preferenceForKey("format")))
			g_Conf.format = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("mood_text_index")))
			g_Conf.mood_text_index = temp;

		if(g_Conf.preset_text[0] == "")
			g_Conf.preset_text[0] = g_Conf.format;

		if(!IsUndefined(temp = widget.preferenceForKey("itunes_paused")))
			g_Conf.itunes_paused = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("paused_index")))
			g_Conf.paused_index = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("use_growl")))
			g_Conf.use_growl = temp;

		for(i in g_Conf.im_services)
		{
			if(!IsUndefined(temp = widget.preferenceForKey("use_" + i)))
				g_Conf.im_services[i].use = temp;
		}

		for(i in g_Conf.post_services)
		{
			if(!IsUndefined(temp = widget.preferenceForKey("use_" + i)))
				g_Conf.post_services[i].use = temp;

			if(!IsUndefined(temp = widget.preferenceForKey(i + "_id")))
				g_Conf.post_services[i].id = temp;

			if(!IsUndefined(temp = widget.preferenceForKey(i + "_pw")))
			{
				if(itm_plugin && g_Conf.post_services[i].id)
				{
					if(!IsUndefined(temp = itm_plugin.GetServicePassword(i, g_Conf.post_services[i].id)))
						g_Conf.post_services[i].pw = temp[0];
				}
			}

			if(!IsUndefined(temp = widget.preferenceForKey(i + "_auto")))
				g_Conf.post_services[i].auto = temp;

			if(!IsUndefined(temp = widget.preferenceForKey(i + "_comment_only")))
				g_Conf.post_services[i].comment_only = temp;
		}

		if(!IsUndefined(temp = widget.preferenceForKey("check_for_updates")))
			g_Conf.check_for_updates = temp;

		if(!IsUndefined(temp = widget.preferenceForKey("last_checked")))
			g_Conf.last_checked = temp;

		for(i=0; i<g_Conf.preset_count; i++)
		{
			if(!IsUndefined(temp = widget.preferenceForKey("preset_text" + i)))
				g_Conf.preset_text[i] = temp;
		}
	}
}

function RestorePreferences()
{
	var i, obj;

	var sel_mood   = document.getElementById("select_mood_text"   );
	var sel_preset = document.getElementById("select_preset_index");

	sel_mood.options.length = g_Conf.preset_count;
	for(i=0; i<g_Conf.preset_count; i++)
	{
		sel_mood  .options[i].text  = i + ": " + g_Conf.preset_text[i];
		sel_mood  .options[i].value = g_Conf.preset_text[i];
		sel_preset.options[i].value = g_Conf.preset_text[i];
	}

	sel_mood.selectedIndex = g_Conf.mood_text_index;
	sel_preset.selectedIndex = g_Conf.preset_index;

	if(obj = document.getElementById("itunes_paused"))
		obj.checked = (g_Conf.itunes_paused? true: false);
	if(obj = document.getElementById("select_paused_index"))
		obj.selectedIndex = g_Conf.paused_index;
	if(obj = document.getElementById("preset_text"))
		obj.value = g_Conf.preset_text[g_Conf.preset_index];
	if(obj = document.getElementById("use_growl"))
		obj.checked = (g_Conf.use_growl? true: false);
	if(obj = document.getElementById("itunes_paused"))
		obj.checked = (g_Conf.itunes_paused? true: false);
	if(obj = document.getElementById("check_for_updates"))
		obj.checked = (g_Conf.check_for_updates? true: false);

	for(i in g_Conf.im_services)
	{
		if(obj = document.getElementById("use_" + i))
			obj.checked = (g_Conf.im_services[i].use? true: false);
	}

	for(i in g_Conf.post_services)
	{
		if(obj = document.getElementById("use_" + i))
			obj.checked = (g_Conf.post_services[i].use? true: false);
		if(obj = document.getElementById(i + "_id"))
			obj.value = g_Conf.post_services[i].id;
		if(obj = document.getElementById(i + "_pw"))
			obj.value = g_Conf.post_services[i].pw;
		if(obj = document.getElementById(i + "_auto"))
			obj.checked = (g_Conf.post_services[i].auto? true: false);
		if(obj = document.getElementById(i + "_comment_only"))
			obj.checked = (g_Conf.post_services[i].comment_only? true: false);
	}
}

//////// Save preferences
function SavePreferences(save_service_password)
{
	var i;

	if(window.widget)
	{
		widget.setPreferenceForKey(g_Conf.mood_text_index    , "mood_text_index"  );
		widget.setPreferenceForKey(g_Conf.itunes_paused      , "itunes_paused"    );
		widget.setPreferenceForKey(g_Conf.paused_index       , "paused_index"     );
		widget.setPreferenceForKey(g_Conf.use_growl          , "use_growl"        );
		widget.setPreferenceForKey(g_Conf.check_for_updates  , "check_for_updates");
		widget.setPreferenceForKey(g_Conf.last_checked       , "last_checked"     );

		widget.setPreferenceForKey(g_Conf.format             , "format"           );
		for(i=0; i<g_Conf.preset_count; i++)
		{
			widget.setPreferenceForKey(g_Conf.preset_text[i], "preset_text" + i  );
		}

		for(i in g_Conf.im_services)
		{
			widget.setPreferenceForKey(g_Conf.im_services[i].use, "use_" + i);
		}

		for(i in g_Conf.post_services)
		{
			widget.setPreferenceForKey(g_Conf.post_services[i].use         , "use_" + i         );
			widget.setPreferenceForKey(g_Conf.post_services[i].id          , i + "_id"          );
			widget.setPreferenceForKey(g_Conf.post_services[i].pw? "*": "" , i + "_pw"          );
			widget.setPreferenceForKey(g_Conf.post_services[i].auto        , i + "_auto"        );
			widget.setPreferenceForKey(g_Conf.post_services[i].comment_only, i + "_comment_only");

			if(itm_plugin && (save_service_password == null || save_service_password))
			{
				if(g_Conf.post_services[i].use && g_Conf.post_services[i].id)
					itm_plugin.SetServicePassword(i, g_Conf.post_services[i].id, g_Conf.post_services[i].pw);
			}
		}
	}
}

function StorePreferences()
{
	var i, obj;

	var sel_mood   = document.getElementById("select_mood_text"   );
	var sel_preset = document.getElementById("select_preset_index");

	for(i=0; i<g_Conf.preset_count; i++)
	{
		sel_mood.options[i].text = i + ": " + sel_preset.options[i].value;
		sel_mood.options[i].value = sel_preset.options[i].value;
		g_Conf.preset_text[i] = sel_preset.options[i].value;
	}
	g_Conf.format = g_Conf.preset_text[g_Conf.mood_text_index];

	g_Conf.mood_text_index = sel_mood.selectedIndex;
	g_Conf.preset_index    = sel_preset.selectedIndex;

	if(obj = document.getElementById("itunes_paused"))
		g_Conf.itunes_paused = (obj.checked? 1: 0);
	if(obj = document.getElementById("select_paused_index"))
		g_Conf.paused_index = obj.selectedIndex;
	if(obj = document.getElementById("use_growl"))
		g_Conf.use_growl = (obj.checked? 1: 0);
	if(obj = document.getElementById("check_for_updates"))
		g_Conf.check_for_updates = (obj.checked? 1: 0);

	for(i in g_Conf.im_services)
	{
		if(obj = document.getElementById("use_" + i))
			g_Conf.im_services[i].use = (obj.checked? 1: 0);
	}

	for(i in g_Conf.post_services)
	{
		if(obj = document.getElementById("use_" + i))
			g_Conf.post_services[i].use = (obj.checked? 1: 0);
		if(obj = document.getElementById(i + "_id"))
			g_Conf.post_services[i].id = obj.value;
		if(obj = document.getElementById(i + "_pw"))
			g_Conf.post_services[i].pw = obj.value;
		if(obj = document.getElementById(i + "_auto"))
			g_Conf.post_services[i].auto = (obj.checked? 1: 0);
		if(obj = document.getElementById(i + "_comment_only"))
			g_Conf.post_services[i].comment_only = (obj.checked? 1: 0);
	}
}

//////// Show mood text selection
function ShowSelectMoodText()
{
	if(g_bSelectMoodTextShown) return;

	if(g_SelectMoodTextAnimator)
	{
		g_SelectMoodTextAnimator.stop();
		delete g_SelectMoodTextAnimator;
		delete g_SelectMoodTextAnimation;
		g_SelectMoodTextAnimator = null;
		g_SelectMoodTextAnimation = null;
	}

	document.getElementById("info").className = "select_shown";

	g_bSelectMoodTextShown = true;

	g_SelectMoodTextAnimator = new AppleAnimator(500, 13);
	g_SelectMoodTextAnimator.oncomplete = SelectMoodText_AnimationComplete;
	g_SelectMoodTextAnimation = new AppleAnimation(0.0, 1.0, SelectMoodText_UpdateOpacity);
	g_SelectMoodTextAnimator.addAnimation(g_SelectMoodTextAnimation);
	g_SelectMoodTextAnimator.start();
}

//////// Hide mood text selection
function HideSelectMoodText()
{
	if(!g_bSelectMoodTextShown) return;

	if(g_SelectMoodTextAnimator)
	{
		g_SelectMoodTextAnimator.stop();
		delete g_SelectMoodTextAnimator;
		delete g_SelectMoodTextAnimation;
		g_SelectMoodTextAnimator = null;
		g_SelectMoodTextAnimation = null;
	}

	g_bSelectMoodTextShown = false;

	g_SelectMoodTextAnimator = new AppleAnimator(500, 13);
	g_SelectMoodTextAnimator.oncomplete = SelectMoodText_AnimationComplete;
	g_SelectMoodTextAnimation = new AppleAnimation(1.0, 0.0, SelectMoodText_UpdateOpacity);
	g_SelectMoodTextAnimator.addAnimation(g_SelectMoodTextAnimation);
	g_SelectMoodTextAnimator.start();
}

//////// Handler for animation
function SelectMoodText_UpdateOpacity(animation, now, first, done)
{
	document.getElementById("select_bg").style.opacity = now;
}

//////// Handler for animation
function SelectMoodText_AnimationComplete()
{
	delete g_SelectMoodTextAnimator;
	delete g_SelectMoodTextAnimation;
	g_SelectMoodTextAnimator = null;
	g_SelectMoodTextAnimation = null;

	if(!g_bSelectMoodTextShown)
		document.getElementById("info").className = "";
}

//////// Mood text selection changed
function MoodTextChanged()
{
	var sel_mood = document.getElementById("select_mood_text");

	g_Conf.format = sel_mood.value;
	g_Conf.mood_text_index = sel_mood.selectedIndex;
	if(window.widget)
	{
		widget.setPreferenceForKey(g_Conf.format, "format");
		widget.setPreferenceForKey(g_Conf.mood_text_index, "mood_text_index");
	}

	SetMoodText();
}

//////// Show preferences
function ShowPrefs()
{
	window.resizeBy(0, g_Conf.back_height - (g_Conf.front_height + (IsPostServiceEnabled()? g_Conf.post_offset: 0)));

	if(window.widget)
		widget.prepareForTransition("ToBack");

	document.getElementById("front").style.display = "none";
	document.getElementById("back" ).style.display = "block";

	if(window.widget)
		window.setTimeout(function(){widget.performTransition();}, 0);
}

//////// Hide preferences
function HidePrefs()
{
	if(window.widget)
		widget.prepareForTransition("ToFront");

	document.getElementById("front").style.display = "block";
	document.getElementById("back" ).style.display = "none";

	if(window.widget)
		window.setTimeout(function(){widget.performTransition();}, 0);

	window.resizeBy(0, (g_Conf.front_height + (IsPostServiceEnabled()? g_Conf.post_offset: 0) - g_Conf.back_height));
	g_InfoButton._frontOutDelay();
	g_InfoButton._labelOut();
}

//////// Hide preferences and cancel changes
function HidePrefsWithoutApplyChanges()
{
	RestorePreferences();
	HidePrefs();
	UsePresetTextWheniTunesPausesChecked();
	UpdateServicesStatus();
}

//////// Hide preferences and apply changes
function HidePrefsWithApplyChanges()
{
	StorePreferences();
	SavePreferences();
	HidePrefs();
	
	g_Conf.cancel_auto_posting = 1;
	
	SetMoodText();
	UpdatePostButton("");
	EnablePostButton();
}

//////// Event handlers for back side
function UsePresetTextWheniTunesPausesChecked()
{
	var flag = document.getElementById("itunes_paused").checked;
	document.getElementById("select_paused_index").disabled = !flag;
}

function PresetIndexChanged()
{
	var sel_preset = document.getElementById("select_preset_index");

	g_Conf.preset_index = sel_preset.selectedIndex;
	document.getElementById("preset_text").value = sel_preset.value;
}

function PresetTextUpdated()
{
	document.getElementById("select_preset_index").options[g_Conf.preset_index].value = document.getElementById("preset_text").value;
}

function PrefsTabMouseOver(e, obj)
{
	if(!HasClassName(obj, "active"))
		AddClassName(obj, "over");
}

function PrefsTabMouseOut(e, obj)
{
	if(!HasClassName(obj, "active"))
		RemoveClassName(obj, "over");
}

function PrefsTabClicked(index)
{
	for(var i=1; i<=g_Conf.prefs_tab_count; i++)
	{
		if(i != index)
		{
			RemoveClassName(document.getElementById("tab" + i), "active", "over");
		}
	}

	document.getElementById("tab" + g_nPrefsTabIndex + "_content").style.display = "none";
	g_nPrefsTabIndex = index;
	AddClassName(document.getElementById("tab" + g_nPrefsTabIndex), "active");
	document.getElementById("tab" + g_nPrefsTabIndex + "_content").style.display = "block";
}

function UsePostServiceChecked(service_name)
{
	var obj, flag = false;

	if(obj = document.getElementById("use_" + service_name))
		flag = obj.checked;

	if(obj = document.getElementById(service_name + "_info"))
		(!flag? AddClassName(obj, "disabled"): RemoveClassName(obj, "disabled"));
	if(obj = document.getElementById(service_name + "_id"))
		obj.disabled = !flag;
	if(obj = document.getElementById(service_name + "_pw"))
		obj.disabled = !flag;
	if(obj = document.getElementById(service_name + "_auto"))
		obj.disabled = !flag;
	if(obj = document.getElementById(service_name + "_comment_only"))
		obj.disabled = !flag;
}

function UpdateServicesStatus()
{
	for(i in g_Conf.post_services)
	{
		UsePostServiceChecked(i);
	}
}

//////// Set format to default setting
function SetFormatDefault()
{
	document.getElementById("preset_text").value = g_Conf.format_default;
	document.getElementById("select_preset_index").options[g_Conf.preset_index].value = g_Conf.format_default;
}

//////// Set mood text
function SetMoodText()
{
	if(!window.widget)
		return;

	// Get track information and set mood text
	if(itm_plugin)
		itm_plugin.UpdateMoodText();
}

//////// Called by itm.widgetplugin
function MoodTextUpdated(state, name, artist, str)
{
	var str = (IsUndefined(str)? "": str);
	document.getElementById("info").innerText = str;
	
	var auto_posting = (g_Conf.mood_text != str && state == "Playing" && !g_Conf.cancel_auto_posting);
	
	g_Conf.mood_text = str;
	g_Conf.current_song = name;
	g_Conf.current_artist = artist;
	
	if(auto_posting && IsPostServiceEnabled())
		BeginPostMoodText(str, true);
	
	g_Conf.cancel_auto_posting = 0;
}

//////// For post services
function IsPostServiceEnabled()
{
	var i, ret = false;
	for(i in g_Conf.post_services)
	{
		ret |= g_Conf.post_services[i].use;
	}

	return ret;
}

function IsPostRequestBusy()
{
	var i, ret = false;
	for(i in g_PostRequest)
	{
		ret |= (g_PostRequest[i] != null);
	}

	return ret;
}

function EnablePostButton()
{
	var flag = IsPostServiceEnabled();

	window.resizeTo(g_Conf.width, g_Conf.front_height + (flag? g_Conf.post_offset: 0));
	document.getElementById("front").className = (flag? "post_service_enabled": "");
}

function PostButtonMouseOver(event, id)
{
	g_nPostButtonStatus = 1;
	if(!IsPostRequestBusy())
	{
		RemoveClassName(event.target, "down");
		AddClassName(event.target, "over");
	}
}

function PostButtonMouseOut(event, id)
{
	g_nPostButtonStatus = 0;
	if(!IsPostRequestBusy())
	{
		RemoveClassName(event.target, "over");
	}
}

function PostButtonClicked()
{
	if(IsPostServiceEnabled())
	{
		var prefix = document.getElementById("post_prefix").value;
		if(prefix != "") prefix += " ";
		BeginPostMoodText(prefix + g_Conf.mood_text);
	}
}

function PostPrefixEntered()
{
	if(IsPostServiceEnabled())
		PostButtonClicked();

	return false;
}

function BeginPostMoodText(str, auto)
{
	var i;

	g_PostErrors = [];
	for(i in g_Conf.post_services)
	{
		var service = g_Conf.post_services[i];
		if(service.use)
		{
			if(!auto || (auto && service.auto))
			{
				var obj;
				if(obj = document.getElementById("post_button"))
				{
					RemoveClassName(obj, "over");
					AddClassName(obj, "down");
				}

				g_nPostCount++;
				if(service.name == "blipfm")
				{
					BlipFm_PostMoodText(service, str);
				}
				else
				{
					PostMoodText(service, str);
				}
			}
		}
	}
}

function EndPostMoodText()
{
	if(g_PostErrors.length < 1)
	{
		UpdatePostButton();
		document.getElementById("post_prefix").value = "";
	}
	else
	{
		UpdatePostButton(g_PostErrors.join("\n"));
	}
}

function PostMoodText(service, str, blipfm_params, blipfm_song)
{
	if(!service) return;

	if(g_PostRequest[service.name])
	{
		g_PostRequest[service.name].abort();
		delete g_PostRequest[service.name];
		g_PostRequest[service.name] = null;
	}

	g_PostRequest[service.name] = new XMLHttpRequest();
	if(g_PostRequest[service.name])
	{
		var url = service.url;
		var params = "", id, pw;

		if(service.comment_only)
		{
			var prefix = document.getElementById("post_prefix").value;
			if(prefix != "")
				str = prefix;
		}

		if(service.name == "blipfm")
		{
			if(str == "")
				str = " ";

			params  = "artist=" + encodeURIComponent(g_Conf.current_artist);
			params += "&title=" + encodeURIComponent(g_Conf.current_song);
			params += "&url=" + blipfm_song.location;
			params += "&blipType=" + blipfm_song.type;
			params += "&message=" + encodeURIComponent(str.substr(0, service.max_length));
			params += "&timestamp=" + blipfm_params.timestamp;
			params += "&nonce=" + blipfm_params.nonce;
			params += "&signature=" + blipfm_params.signature;
			if(blipfm_params.auth)
			{
				id = null;
				pw = null;
			}
			else
			{
				id = service.id;
				pw = service.pw;
			}
		}
		else if(service.name == "friendfeed")
		{
			params  = "title=" + encodeURIComponent(str.substr(0, service.max_length));
			id = service.id;
			pw = service.pw;
		}
		else if(service.name == "jaiku")
		{
			params  = "user=" + encodeURIComponent(service.id);
			params += "&personal_key=" + encodeURIComponent(service.pw);
			params += "&message=" + encodeURIComponent(str.substr(0, service.max_length));
			id = null;
			pw = null;
		}
		else if(service.name == "twitter")
		{
			params  = "status=" + encodeURIComponent(str.substr(0, service.max_length));
			params += "&source=" + encodeURIComponent(g_Conf.app_code);
			id = service.id;
			pw = service.pw;
		}
		else if(service.name == "wassr")
		{
			params  = "status=" + encodeURIComponent(str.substr(0, service.max_length));
			params += "&source=" + encodeURIComponent(g_Conf.app_name);
			id = service.id;
			pw = service.pw;
		}

		if(service.params != "")
			params += "&" + service.params;

		g_PostRequest[service.name].onload = function(e){PostMoodTextDone(g_PostRequest[service.name], service);};
		g_PostRequest[service.name].open("POST", url, true, id, pw);
		if(blipfm_params && blipfm_params.auth)
		{
			var host = url.replace(/^https?\:\/\/|\/.+$/g, "");
			var uri = url.replace(/^https?\:\/\/[^\/]+/, "");
			g_PostRequest[service.name].setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
			g_PostRequest[service.name].setRequestHeader("Host", host);
			g_PostRequest[service.name].setRequestHeader("Authorization", blipfm_params.auth);
		}
		g_PostRequest[service.name].setRequestHeader("Cache-Control", "no-cache");
		g_PostRequest[service.name].setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		g_PostRequest[service.name].setRequestHeader("Content-Length", params.length);
		g_PostRequest[service.name].send(params);

		g_PostTimer[service.name] = window.setTimeout(function(){PostTimedOut(service);}, g_Conf.post_timeout * 1000);
	}
}

function PostMoodTextDone(request, service)
{
	if(g_PostTimer[service.name])
	{
		window.clearTimeout(g_PostTimer[service.name]);
		g_PostTimer[service.name] = null;
	}

	if(request.status == 200)
	{
		// OK
	}
	else
	{
		// Some error occurred
		var error;
		if(service.name == "blipfm")
		{
			var result = eval("(" + request.responseText + ")")
			if(result.error)
				error = result.error.message;
			else if(result.status)
				error = result.status.message;
		}
		else if(service.name == "friendfeed")
		{
			var result = eval("(" + request.responseText + ")")
			if(result.errorCode)
				error = result.errorCode;
		}
		else
		{
			error = g_Conf.post_error[request.status];
		}

		if(!error) error = g_Conf.post_error[999];
		g_PostErrors.push("[" + service.label + ":" + request.status + "] " + error);
	}

	PostMoodTextFinished(service);
}

function PostTimedOut(service)
{
	if(g_PostTimer[service.name])
	{
		window.clearTimeout(g_PostTimer[service.name]);
		g_PostTimer[service.name] = null;
	}

	g_PostErrors.push("[" + service.label + "] " + g_Conf.post_error[998]);

	PostMoodTextFinished(service);
}

function PostMoodTextFinished(service)
{
	if(g_PostRequest[service.name])
	{
		g_PostRequest[service.name].abort();
		delete g_PostRequest[service.name];
		g_PostRequest[service.name] = null;
	}

	if(--g_nPostCount < 1)
		EndPostMoodText();
}

function UpdatePostButton(error)
{
	var obj;
	if(obj = document.getElementById("post_button"))
	{
		RemoveClassName(obj, "down");

		if(g_nPostButtonStatus)
			AddClassName(obj, "over");
		else
			RemoveClassName(obj, "over");

		if(error)
			AddClassName(obj, "error");
		else
			RemoveClassName(obj, "error");

		obj.title = (error? error: "");
	}
}

//// For Blip.fm
function BlipFm_GetParams(method, callback)
{
	var service = g_Conf.post_services["blipfm"];
	var url = service.url_getparams + "?method=" + method;
	var request = new XMLHttpRequest();
	request.onload = function(e){
		if(request.status == 200)
		{
			var params = eval("(" + request.responseText + ")");
			callback(params);
		}
		else
		{
			callback(null);
		}
	};
	request.open("GET", url, true);
	request.setRequestHeader("Cache-Control", "no-cache");
	request.send(null);
}

function BlipFm_GetAuthString(method, url)
{
	var host = url.replace(/^https?\:\/\/|\/.+$/g, "");
	var uri = url.replace(/^https?\:\/\/[^\/]+/, "");

	var request = new XMLHttpRequest();
	request.open(method, url, false);
	request.setRequestHeader("Method", method + " " + uri + " HTTP/1.1");
	request.setRequestHeader("Host", host, "");
	request.setRequestHeader("Cache-Control", "no-cache");
	if(method == "POST")
	{
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.setRequestHeader("Content-Length", 0);
	}
	request.send(null);

	if(request.status != 401)
		return null;

	var header = request.getResponseHeader("WWW-Authenticate");
	if(!header.match(/^Digest (.+)$/))
		return null;

	var temp = (header.replace(/^.+?\s/, "")).split(",");
	var params = {};
	for(var i=0; i<temp.length; i++)
	{
		var pair = temp[i].replace(/^\s+|\s+$/g, "").split("=");
		params[pair[0]] = pair[1].replace(/^"|"$/g, "");
	}

	var service = g_Conf.post_services["blipfm"];

	var nc = Number(++g_nBlipCount).toString(16);
	nc = "0000000" + nc;
	nc = nc.substr(nc.length - 8, 8);
	var cnonce = Md5((new Date).getTime());
	var qop = "auth";
	var response;

	response  = Md5(service.id + ":" + params.realm + ":" + service.pw);
	response += ":" + params.nonce + ":" + nc + ":" + cnonce + ":" + qop + ":";
	response += Md5(method + ":" + uri);
	response  = Md5(response);

	var ret = "Digest username=\"" + service.id + "\"";
	ret += ", realm=\"" + params.realm + "\", uri=\"" + uri + "\"";
	ret += ", nonce=\"" + params.nonce + "\", nc=" + nc + ", cnonce=\"" + cnonce + "\""
	ret += ", qop=" + qop;
	if(!IsNull(params.opaque))
		ret += ", opaque=\"" + params.opaque + "\"";
	ret += ", response=\"" + response + "\"";
	return ret;
}

function BlipFm_FindSongs(name, artist, params, callback)
{
	var service = g_Conf.post_services["blipfm"];
	var url = service.url_findsongs + "?" + service.params;
	url += "&searchTerm=" + encodeURIComponent(name + " - " + artist);
	url += "&timestamp=" + params.timestamp;
	url += "&nonce=" + params.nonce;
	url += "&signature=" + params.signature;

	var request = new XMLHttpRequest();
	request.onload = function(e){
		if(request.status == 200)
		{
			var songs = eval("(" + request.responseText + ")");
			callback(songs);
		}
		else
		{
			callback(null);
		}
	};
	request.open("GET", url, false);
	request.setRequestHeader("Cache-Control", "no-cache");
	request.send(null);
}

function BlipFm_GetSong(name, artist, callback)
{
	var result = {"location":"unavailable", "type":"songUrl"};
	BlipFm_GetParams("GET", function(params){
		BlipFm_FindSongs(name, artist, params, function(songs){
			if(songs && songs.status && songs.status.code == "200" && songs.result)
			{
				if(songs.result.count > 0)
				{
					var song;
					for(var i=0; i<songs.result.count; i++)
					{
//						if(songs.result.count == 1)
//							song = songs.result.collection.Song;
//						else
							song = songs.result.collection.Song[i];

						if(BlipFm_IsSongEqualTo(song, artist, name))
						{
							callback(song);
							return;
						}
					}
				}
			}

			callback(result);
			return;
		});
	});
}

function BlipFm_IsSongEqualTo(song, artist, title)
{
	var check_artist, check_title, pattern_artist, pattern_title;

	artist = QuoteMeta(artist);
	artist = artist.replace(/[\s-_]/g, "[ -_]?");
	title = QuoteMeta(title);
	title = title.replace(/[\s-_]/g, "[ -_]?");

	if(song.artist == "" || song.artist.match(/^no artist$/i))
	{
		check_artist = decodeURIComponent(song.location);
		pattern_artist = new RegExp(artist, "i");
	}
	else
	{
		check_artist = song.artist;
		pattern_artist = new RegExp(artist, "i");
	}

	if(song.title == "" || song.title.match(/^untitled$/i))
	{
		check_title = decodeURIComponent(song.location);
		pattern_title = new RegExp(title, "i");
	}
	else
	{
		check_title = song.title;
		pattern_title = new RegExp(title, "i");
	}


	return (check_artist.match(pattern_artist) && check_title.match(pattern_title));
}

function BlipFm_PostMoodText(service, str)
{
	BlipFm_GetSong(g_Conf.current_song, g_Conf.current_artist, function(song){
		if(!IsNull(song))
		{
			if(song.location != "unavailable")
			{
				BlipFm_GetParams("POST", function(params){
					params.auth = BlipFm_GetAuthString("POST", service.url);
					PostMoodText(service, str, params, song);
				});
			}
			else
			{
				g_PostErrors.push("[" + service.label + "] " + g_Conf.post_error[997]);
				PostMoodTextFinished(service);
			}
		}
	});
}

//////// Check for updates
function CheckForUpdates()
{
	if(!g_Conf.check_for_updates)
		return;

	var date = new Date();
	if(date.getTime() <= g_Conf.last_checked + g_Conf.check_for_upd_every * 1000)
		return;

	g_Conf.last_checked = date.getTime();
	SavePreferences();

	if(g_CheckForUpdatesRequest)
	{
		g_CheckForUpdatesRequest.abort();
		delete g_CheckForUpdatesRequest;
		g_CheckForUpdatesRequest = null;
	}

	g_CheckForUpdatesRequest = new XMLHttpRequest();
	if(g_CheckForUpdatesRequest)
	{
		g_CheckForUpdatesRequest.onload = function(e){CheckForUpdatesDone(g_CheckForUpdatesRequest);};
		g_CheckForUpdatesRequest.open("GET", g_Conf.check_for_upd_url, true);
		g_CheckForUpdatesRequest.setRequestHeader("Cache-Control", "no-cache");
		g_CheckForUpdatesRequest.send("");

		g_CheckForUpdatesTimer = window.setTimeout(function(){CheckForUpdatesTimedOut();}, g_Conf.check_for_upd_timeout * 1000);
	}
}

function CheckForUpdatesDone(request)
{
	if(g_CheckForUpdatesTimer)
	{
		window.clearTimeout(g_CheckForUpdatesTimer);
		g_CheckForUpdatesTimer = null;
	}

	if(request.status == 200)
	{
		var ver_local = {ver:0, beta:0}, ver_server = {ver:0, beta:0};
		
		if(g_Conf.version.match(/ver\.([\d.]+)(b(\d+))?/))
		{
			ver_local.ver = RegExp.$1;
			ver_local.beta = RegExp.$3;
		}

		if(request.responseText.match(/ver\.([\d.]+)(b(\d+))?/))
		{
			ver_server.ver = RegExp.$1;
			ver_server.beta = RegExp.$3;
		}

		if(
			(ver_server.ver > ver_local.ver) || 
			(ver_server.ver == ver_local.ver && ((!ver_server.beta && ver_local.beta) || (ver_server.beta > ver_local.beta)))
		)
		{
			// New version found
			document.getElementById("updated_button").style.display = "block";
		}
	}

	if(g_CheckForUpdatesRequest)
	{
		delete g_CheckForUpdatesRequest;
		g_CheckForUpdatesRequest = null;
	}
}

function CheckForUpdatesTimedOut()
{
	if(g_CheckForUpdatesTimer)
	{
		window.clearTimeout(g_CheckForUpdatesTimer);
		g_CheckForUpdatesTimer = null;
	}

	if(g_CheckForUpdatesRequest)
	{
		g_CheckForUpdatesRequest.abort();
		delete g_CheckForUpdatesRequest;
		g_CheckForUpdatesRequest = null;
	}
}

function UpdatedButtonClicked()
{
	if(window.widget)
		window.widget.openURL("http://www.mybdesign.com/itm/");
}

//////// Common functions
function IsNull(obj)
{
	return (obj == null);
}

function IsUndefined(obj)
{
	return (typeof(obj) == "undefined");
}

function HasClassName(obj, name)
{
	var regexp = new RegExp("\\b" + name + "\\b");
	return obj.className.match(regexp);
}

function AddClassName(obj)
{
	for(var i=1; i<arguments.length; i++)
	{
		if(!HasClassName(obj, arguments[i]))
			obj.className += (obj.className? " ": "") + arguments[i];
	}
}

function RemoveClassName(obj)
{
	for(var i=1; i<arguments.length; i++)
	{
		var regexp = new RegExp("^" + arguments[i] + "\\s*|\\s*" + arguments[i] + "\\b");
		obj.className = obj.className.replace(regexp, "");
	}
}

function QuoteMeta(str)
{
	return str.replace(/([.\\+*?\[^\]($)|])/g, "\\$1");
}

function Md5(str)
{
	str = String(str).replace(/([\"\`\$\\])/g, function(){ return "\\" + RegExp.$1; });	//"
	var ret = (widget.system("/sbin/md5 -s \"" + str + "\"", null)).outputString;
	if(ret.match(/(\S+)\s*$/))
		return RegExp.$1;
	else
		return "";
}
